#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/udplite.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h> /* close() */
#include <string.h> /* memset() */

#define LOCAL_SERVER_PORT 15500
#define MAX_MSG 100

int main(int argc, char *argv[]) {

    int sd, rc, n, cliLen;
    struct sockaddr_in cliAddr, servAddr;
    char msg[MAX_MSG];
	int val = 0;

    /* socket creation */
    sd=socket(AF_INET, SOCK_LDGRAM, 0);
    if(sd<0) {
        printf("%s: cannot open socket \n",argv[0]);
        exit(1);
    }

    /* bind local server port */
    servAddr.sin_family = PF_INET;
    servAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servAddr.sin_port = htons(LOCAL_SERVER_PORT);
    rc = bind (sd, (struct sockaddr *) &servAddr,sizeof(servAddr));
    if(rc<0) {
        printf("rc=%d \n",rc);
        printf("%s: cannot bind port number %d \n", 
                argv[0], LOCAL_SERVER_PORT);
        exit(1);
    }
	
	setsockopt(sd,SOL_UDPLITE,UDPLITE_RECV_CHCKLEN,&val,sizeof(int));
	
    printf("%s: waiting for data on port UDPLITE %u\n", 
            argv[0],LOCAL_SERVER_PORT);

    /* server infinite loop */
    while(1) {

        /* init buffer */
        memset(msg,0x0,MAX_MSG);


        /* receive message */
        cliLen = sizeof(cliAddr);
        n = recvfrom(sd, msg, MAX_MSG, 0, 
                (struct sockaddr *) &cliAddr, &cliLen);

        if(n<0) {
            printf("%s: cannot receive data \n",argv[0]);
            continue;
        }

        /* print received message */
        printf("%s: from %s:UDPLITE %u : %s \n", 
                argv[0],inet_ntoa(cliAddr.sin_addr),
                ntohs(cliAddr.sin_port),msg);

    }/* end of server infinite loop */

    return 0;

}

